/*------------------------------------------------------------------------------
 * MDK Middleware - Component ::USB:Device
 * Copyright (c) 2004-2016 ARM Germany GmbH. All rights reserved.
 *------------------------------------------------------------------------------
 * Name:    usb_os.h
 * Purpose: USB Library OS specific definitions
 * Rev.:    V6.9.0
 *----------------------------------------------------------------------------*/

#ifndef __USB_OS_H__
#define __USB_OS_H__

#include "cmsis_os.h"

#if (osCMSIS < 0x20000U)

#if !defined (osThreadExt)
/// External reference to a Thread Definition
/// \param         name         name of the thread.
#define osThreadExt(name)                                       \
extern const osThreadDef_t os_thread_def_##name
#endif

#if !defined (osTimerExt)
/// External reference to a Timer Definition
/// \param         name         name of the timer.
#define osTimerExt(name)                                        \
extern uint32_t os_timer_cb_##name[6];                          \
extern const osTimerDef_t os_timer_def_##name
#endif

#if !defined (osMutexExt)
/// External reference to a Thread Definition
/// \param         name         name of the mutex.
#define osMutexExt(name)                                        \
extern uint32_t os_mutex_cb_##name[4];                          \
extern const osMutexDef_t os_mutex_def_##name
#endif

#if !defined (osSemaphoreExt)
/// External reference to a Thread Definition
/// \param         name         name of the semaphore.
#define osSemaphoreExt(name)                                    \
extern uint32_t os_semaphore_cb_##name[2];                      \
extern const osSemaphoreDef_t os_semaphore_def_##name
#endif

#else

#if !defined (osThreadExt)
/// External reference to a Thread Definition
/// \param         name         name of the thread.
#define osThreadExt(name)                                       \
extern const osThreadDef_t os_thread_def_##name
#endif

#if !defined (osTimerExt)
/// External reference to a Timer Definition
/// \param         name         name of the timer.
#define osTimerExt(name)                                        \
extern const osTimerDef_t os_timer_def_##name
#endif

#if !defined (osMutexExt)
/// External reference to a Thread Definition
/// \param         name         name of the mutex.
#define osMutexExt(name)                                        \
extern const osMutexDef_t os_mutex_def_##name
#endif

#if !defined (osSemaphoreExt)
/// External reference to a Thread Definition
/// \param         name         name of the semaphore.
#define osSemaphoreExt(name)                                    \
extern const osSemaphoreDef_t os_semaphore_def_##name
#endif

#endif  // (osCMSIS < 0x20000U)

#endif  // __USB_OS_H__
