/*------------------------------------------------------------------------------
 * MDK Middleware - Component ::USB:Device
 * Copyright (c) 2004-2016 ARM Germany GmbH. All rights reserved.
 *------------------------------------------------------------------------------
 * Name:    usbh_compatibility.h
 * Purpose: USB Device Library Compatibility module
 * Rev.:    V6.8.0
 *----------------------------------------------------------------------------*/

#ifndef __USBH_COMPATIBILITY__
#define __USBH_COMPATIBILITY__

/*------------------------------------------------------------------------------
 *      USB Host 0..3 compatibility defines
 *----------------------------------------------------------------------------*/

#ifdef  RTE_USB_Host_0
#ifndef USBH0_HC_POWER
#define USBH0_HC_POWER                            500
#endif
#ifndef USBH0_HC_OHCI_POWER
#define USBH0_HC_OHCI_POWER                       500
#endif
#ifndef USBH0_HC_EHCI_POWER
#define USBH0_HC_EHCI_POWER                       500
#endif
#endif

#ifdef  RTE_USB_Host_1
#ifndef USBH1_HC_POWER
#define USBH1_HC_POWER                            500
#endif
#ifndef USBH1_HC_OHCI_POWER
#define USBH1_HC_OHCI_POWER                       500
#endif
#ifndef USBH1_HC_EHCI_POWER
#define USBH1_HC_EHCI_POWER                       500
#endif
#endif

#ifdef  RTE_USB_Host_2
#ifndef USBH2_HC_POWER
#define USBH2_HC_POWER                            500
#endif
#ifndef USBH2_HC_OHCI_POWER
#define USBH2_HC_OHCI_POWER                       500
#endif
#ifndef USBH2_HC_EHCI_POWER
#define USBH2_HC_EHCI_POWER                       500
#endif
#endif

#ifdef  RTE_USB_Host_3
#ifndef USBH3_HC_POWER
#define USBH3_HC_POWER                            500
#endif
#ifndef USBH3_HC_OHCI_POWER
#define USBH3_HC_OHCI_POWER                       500
#endif
#ifndef USBH3_HC_EHCI_POWER
#define USBH3_HC_EHCI_POWER                       500
#endif
#endif

/*------------------------------------------------------------------------------
 *      USB Host HID compatibility defines
 *----------------------------------------------------------------------------*/

#ifdef  RTE_USB_Host_HID
#ifdef  USBH0_HID_THREAD_STACK_SIZE
#define USBH_HID_INT_IN_THREAD_STACK_SIZE             USBH0_HID_THREAD_STACK_SIZE
#endif
#ifndef USBH_HID_INT_IN_THREAD_STACK_SIZE
#define USBH_HID_INT_IN_THREAD_STACK_SIZE             512
#endif
#ifdef  USBH0_HID_THREAD_PRIORITY
#define USBH_HID_INT_IN_THREAD_PRIORITY               USBH0_HID_THREAD_PRIORITY
#endif
#ifndef USBH_HID_INT_IN_THREAD_PRIORITY
#define USBH_HID_INT_IN_THREAD_PRIORITY               osPriorityAboveNormal
#endif
#endif

#endif // __USBH_COMPATIBILITY__
