/*------------------------------------------------------------------------------
 * MDK Middleware - Component ::USB:Host
 * Copyright (c) 2004-2016 ARM Germany GmbH. All rights reserved.
 *------------------------------------------------------------------------------
 * Name:    usbh_config_hc_2.c
 * Purpose: USB Host Host Controller 2 Data and Settings
 * Rev.:    V6.9.0
 *----------------------------------------------------------------------------*/

#include "usb_os.h"


#if     (USBH2_HC_IF == 0)              // Custom

#if     (USBH2_HC_MEM_POOL_RELOC == 1)
#if      defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
#define  __AT_MEM2__(x)                             __attribute__((section(".ARM.__AT_"#x)))
#define  __AT_MEM2(x)                               __AT_MEM2__(x)
#else
#define  __AT_MEM2(x)                               __attribute__((at(x)))
#endif
#else
#define  __AT_MEM2(x)
#endif
#define  __ALIGNED_MEM2(x)                          __attribute__((aligned(x)))

#ifndef  USBH2_HC_PIPE_NUM
#define  USBH2_HC_PIPE_NUM                            USBH2_HC_ENDPOINT_NUM
#endif

#if     (USBH2_HC_MEM_POOL_SIZE < 512)
#warning Memory Pool Size for Host Controller 2 not recommended less than 512 bytes!
#endif

extern   USBH_PIPE            usbh2_pipe             [USBH2_HC_PIPE_NUM];
         USBH_PIPE            usbh2_pipe             [USBH2_HC_PIPE_NUM];
extern   USBH_PIPE_TID_t      usbh2_pipe_tid         [USBH2_HC_PIPE_NUM];
         USBH_PIPE_TID_t      usbh2_pipe_tid         [USBH2_HC_PIPE_NUM];
extern 
const    uint32_t             usbh2_pipe_num;
const    uint32_t             usbh2_pipe_num =        USBH2_HC_PIPE_NUM;

extern 
const    uint32_t             usbh2_transfer_num;
const    uint32_t             usbh2_transfer_num =    USBH2_HC_PIPE_NUM;

extern   ARM_DRIVER_USBH                              USBHn_DRIVER(USBH2_HC_NUM);
extern 
const    ARM_DRIVER_USBH     *usbh2_hcd_ptr;
const    ARM_DRIVER_USBH     *usbh2_hcd_ptr  =       &USBHn_DRIVER(USBH2_HC_NUM);
extern 
const    ARM_DRIVER_USBH_HCI *usbh2_hci_hcd_ptr;
const    ARM_DRIVER_USBH_HCI *usbh2_hci_hcd_ptr =     NULL;

extern 
const    uint8_t              usbh2_power;
const    uint8_t              usbh2_power =          (uint8_t)(USBH2_HC_POWER/2);
extern 
const    uint8_t              usbh2_mem_pool_reloc;
const    uint8_t              usbh2_mem_pool_reloc =  USBH2_HC_MEM_POOL_RELOC;
extern   uint32_t             usbh2_mem_pool        [(USBH2_HC_MEM_POOL_SIZE + 8 * USBH2_HC_PIPE_NUM + 32 + 4 +3)/4];
         uint32_t             usbh2_mem_pool        [(USBH2_HC_MEM_POOL_SIZE + 8 * USBH2_HC_PIPE_NUM + 32 + 4 +3)/4] __AT_MEM2(USBH2_HC_MEM_POOL_ADDR);
extern 
const    uint32_t             usbh2_mem_pool_size;
const    uint32_t             usbh2_mem_pool_size = ((USBH2_HC_MEM_POOL_SIZE + 8 * USBH2_HC_PIPE_NUM + 32 + 4 +3)/4)*4;

extern   USBH_HC_t            usbh2_hc;
         USBH_HC_t            usbh2_hc       =      { USBH2_HC_PIPE_NUM };
extern   USBH_HC_t           *usbh2_hc_ptr;
         USBH_HC_t           *usbh2_hc_ptr   =       &usbh2_hc;
extern   USBH_OHCI_t         *usbh2_ohci_ptr;
         USBH_OHCI_t         *usbh2_ohci_ptr =        NULL;
extern   USBH_EHCI_t         *usbh2_ehci_ptr;
         USBH_EHCI_t         *usbh2_ehci_ptr =        NULL;

#elif   (USBH2_HC_IF == 1)              // OHCI

#if     (USBH2_HC_OHCI_MEM_POOL_RELOC == 1)
#if      defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
#define  __AT_MEM2__(x)                             __attribute__((section(".ARM.__AT_"#x)))
#define  __AT_MEM2(x)                               __AT_MEM2__(x)
#define  __SECTION_MEM2(x)
#else
#define  __AT_MEM2(x)                               __attribute__((at(x)))
#define  __SECTION_MEM2(x)
#endif
#else
#define  __AT_MEM2(x)
#define  __SECTION_MEM2(x)                          __attribute__((section(#x)))
#endif
#define  __ALIGNED_MEM2(x)                          __attribute__((aligned(x)))

#ifndef  USBH2_HC_OHCI_PIPE_NUM
#define  USBH2_HC_OHCI_PIPE_NUM                       USBH2_HC_OHCI_ENDPOINT_NUM
#endif

#if     (USBH2_HC_OHCI_MEM_POOL_SIZE < 512)
#warning Memory Pool Size for Host Controller 2 not recommended less than 512 bytes!
#endif

extern   USBH_PIPE            usbh2_pipe             [USBH2_HC_OHCI_PIPE_NUM];
         USBH_PIPE            usbh2_pipe             [USBH2_HC_OHCI_PIPE_NUM];
extern   USBH_PIPE_TID_t      usbh2_pipe_tid         [USBH2_HC_OHCI_PIPE_NUM];
         USBH_PIPE_TID_t      usbh2_pipe_tid         [USBH2_HC_OHCI_PIPE_NUM];
extern 
const    uint32_t             usbh2_pipe_num;
const    uint32_t             usbh2_pipe_num =        USBH2_HC_OHCI_PIPE_NUM;

extern   USBH_TRANSFER_INFO_t usbh2_transfer_info    [USBH2_HC_OHCI_PIPE_NUM];
         USBH_TRANSFER_INFO_t usbh2_transfer_info    [USBH2_HC_OHCI_PIPE_NUM];
extern 
const    uint32_t             usbh2_transfer_num;
const    uint32_t             usbh2_transfer_num =    USBH2_HC_OHCI_PIPE_NUM;

extern   ARM_DRIVER_USBH                              USBHn_DRIVER_OHCI_LIB(2);

extern 
const    ARM_DRIVER_USBH     *usbh2_hcd_ptr;
const    ARM_DRIVER_USBH     *usbh2_hcd_ptr =        &USBHn_DRIVER_OHCI_LIB(2);

extern   ARM_DRIVER_USBH_HCI                          USBHn_DRIVER_HCI(USBH2_HC_NUM);
extern 
const    ARM_DRIVER_USBH_HCI *usbh2_hci_hcd_ptr;
const    ARM_DRIVER_USBH_HCI *usbh2_hci_hcd_ptr =    &USBHn_DRIVER_HCI(USBH2_HC_NUM);

#define  USBH2_OHCI_MEM_HCCA                         (USBH2_HC_OHCI_MEM_POOL_ADDR)
#define  USBH2_OHCI_MEM_HCCA_SIZE                    (256)
#define  USBH2_OHCI_MEM_ED                           (USBH2_OHCI_MEM_HCCA + USBH2_OHCI_MEM_HCCA_SIZE)
#define  USBH2_OHCI_MEM_ED_SIZE                      (USBH2_HC_OHCI_PIPE_NUM*16)
#define  USBH2_OHCI_MEM_TD                           (USBH2_OHCI_MEM_ED   + USBH2_OHCI_MEM_ED_SIZE)
#define  USBH2_OHCI_MEM_TD_SIZE                      (USBH2_HC_OHCI_PIPE_NUM*16)
#define  USBH2_OHCI_MEM_POOL_ADDR                    (USBH2_OHCI_MEM_HCCA + USBH2_OHCI_MEM_HCCA_SIZE + USBH2_OHCI_MEM_ED_SIZE + USBH2_OHCI_MEM_TD_SIZE)
#define  USBH2_OHCI_MEM_POOL_SIZE                    (USBH2_HC_OHCI_MEM_POOL_SIZE + 8 * USBH2_HC_PIPE_NUM + 32 + 4)

extern   uint32_t             usbh2_ohci_hcca       [(USBH2_OHCI_MEM_HCCA_SIZE +3)/4];
#if defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
         uint32_t             usbh2_ohci_hcca       [(USBH2_OHCI_MEM_HCCA_SIZE +3)/4] __AT_MEM2(USBH2_HC_OHCI_MEM_POOL_ADDR) __SECTION_MEM0(USBH2_OHCI_HCCA) __ALIGNED_MEM2(256);
#else
         uint32_t             usbh2_ohci_hcca       [(USBH2_OHCI_MEM_HCCA_SIZE +3)/4] __AT_MEM2(USBH2_OHCI_MEM_HCCA)         __SECTION_MEM0(USBH2_OHCI_HCCA) __ALIGNED_MEM2(256);
#endif
extern   uint32_t             usbh2_ohci_ed         [(USBH2_OHCI_MEM_ED_SIZE   +3)/4];
#if defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
         uint32_t             usbh2_ohci_ed         [(USBH2_OHCI_MEM_ED_SIZE   +3)/4] __AT_MEM2(USBH2_HC_OHCI_MEM_POOL_ADDR) __ALIGNED_MEM2(16);
#else
         uint32_t             usbh2_ohci_ed         [(USBH2_OHCI_MEM_ED_SIZE   +3)/4] __AT_MEM2(USBH2_OHCI_MEM_ED)           __ALIGNED_MEM2(16);
#endif
extern   uint32_t             usbh2_ohci_td         [(USBH2_OHCI_MEM_TD_SIZE   +3)/4];
#if defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
         uint32_t             usbh2_ohci_td         [(USBH2_OHCI_MEM_TD_SIZE   +3)/4] __AT_MEM2(USBH2_HC_OHCI_MEM_POOL_ADDR) __ALIGNED_MEM2(16);
#else
         uint32_t             usbh2_ohci_td         [(USBH2_OHCI_MEM_TD_SIZE   +3)/4] __AT_MEM2(USBH2_OHCI_MEM_TD)           __ALIGNED_MEM2(16);
#endif
extern   
const    uint8_t              usbh2_power;
const    uint8_t              usbh2_power =          (uint8_t)(USBH2_HC_OHCI_POWER/2);
extern
const    uint8_t              usbh2_mem_pool_reloc;
const    uint8_t              usbh2_mem_pool_reloc =  USBH2_HC_OHCI_MEM_POOL_RELOC;
extern   uint32_t             usbh2_mem_pool        [(USBH2_OHCI_MEM_POOL_SIZE +3)/4];
#if defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
         uint32_t             usbh2_mem_pool        [(USBH2_OHCI_MEM_POOL_SIZE +3)/4] __AT_MEM2(USBH2_HC_OHCI_MEM_POOL_ADDR);
#else
         uint32_t             usbh2_mem_pool        [(USBH2_OHCI_MEM_POOL_SIZE +3)/4] __AT_MEM2(USBH2_OHCI_MEM_POOL_ADDR);
#endif
extern 
const    uint32_t             usbh2_mem_pool_size;
const    uint32_t             usbh2_mem_pool_size = ((USBH2_OHCI_MEM_POOL_SIZE +3)/4)*4;

extern   USBH_OHCI_t          usbh2_ohci;
         USBH_OHCI_t          usbh2_ohci = {         (uint32_t *)USBH2_HC_OHCI_BASE_ADDRESS,
                                                      USBH2_HC_OHCI_PIPE_NUM,
                                                      USBH2_HC_OHCI_PIPE_NUM,
                                                      0U,
                                                      0U, // padding byte
                                                     &usbh2_ohci_hcca[0],
                                                     &usbh2_ohci_ed[0],
                                                     &usbh2_ohci_td[0],
                                                      NULL,
                                                     &usbh2_transfer_info[0] };
extern   USBH_HC_t           *usbh2_hc_ptr;
         USBH_HC_t           *usbh2_hc_ptr   =        NULL;
extern   USBH_OHCI_t         *usbh2_ohci_ptr;
         USBH_OHCI_t         *usbh2_ohci_ptr =       &usbh2_ohci;
extern   USBH_EHCI_t         *usbh2_ehci_ptr;
         USBH_EHCI_t         *usbh2_ehci_ptr =        NULL;

#elif   (USBH2_HC_IF == 2)              // NXP EHCI with extensions for full/low-speed support

#if     (USBH2_HC_EHCI_MEM_POOL_RELOC == 1)
#if      defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
#define  __AT_MEM2__(x)                             __attribute__((section(".ARM.__AT_"#x)))
#define  __AT_MEM2(x)                               __AT_MEM2__(x)
#define  __SECTION_MEM2(x)
#else
#define  __AT_MEM2(x)                               __attribute__((at(x)))
#define  __SECTION_MEM2(x)
#endif
#else
#define  __AT_MEM2(x)
#define  __SECTION_MEM2(x)                          __attribute__((section(#x)))
#endif
#define  __ALIGNED_MEM2(x)                          __attribute__((aligned(x)))

#ifndef  USBH2_HC_EHCI_PIPE_NUM
#define  USBH2_HC_EHCI_PIPE_NUM                       USBH2_HC_EHCI_ENDPOINT_NUM
#endif

#if     (USBH2_HC_EHCI_MEM_POOL_SIZE < 512)
#warning Memory Pool Size for Host Controller 2 not recommended less than 512 bytes!
#endif

extern   USBH_PIPE            usbh2_pipe             [USBH2_HC_EHCI_PIPE_NUM];
         USBH_PIPE            usbh2_pipe             [USBH2_HC_EHCI_PIPE_NUM];
extern   USBH_PIPE_TID_t      usbh2_pipe_tid         [USBH2_HC_EHCI_PIPE_NUM];
         USBH_PIPE_TID_t      usbh2_pipe_tid         [USBH2_HC_EHCI_PIPE_NUM];
extern 
const    uint32_t             usbh2_pipe_num;
const    uint32_t             usbh2_pipe_num =        USBH2_HC_EHCI_PIPE_NUM;

extern   USBH_TRANSFER_INFO_t usbh2_transfer_info    [USBH2_HC_EHCI_PIPE_NUM];
         USBH_TRANSFER_INFO_t usbh2_transfer_info    [USBH2_HC_EHCI_PIPE_NUM];
extern 
const    uint32_t             usbh2_transfer_num;
const    uint32_t             usbh2_transfer_num =    USBH2_HC_EHCI_PIPE_NUM;

extern   ARM_DRIVER_USBH                              USBHn_DRIVER_EHCI_LIB(2);
extern 
const    ARM_DRIVER_USBH     *usbh2_hcd_ptr;
const    ARM_DRIVER_USBH     *usbh2_hcd_ptr =        &USBHn_DRIVER_EHCI_LIB(2);

extern   ARM_DRIVER_USBH_HCI                          USBHn_DRIVER_HCI(USBH2_HC_NUM);
extern 
const    ARM_DRIVER_USBH_HCI *usbh2_hci_hcd_ptr;
const    ARM_DRIVER_USBH_HCI *usbh2_hci_hcd_ptr =    &USBHn_DRIVER_HCI(USBH2_HC_NUM);

#define  USBH2_EHCI_MEM_PFL                          (USBH2_HC_EHCI_MEM_POOL_ADDR + (((USBH2_HC_EHCI_MEM_POOL_SIZE + 3)/4)*4))
#define  USBH2_EHCI_MEM_PFL_SIZE                     (4096)
#define  USBH2_EHCI_MEM_QH                           (USBH2_EHCI_MEM_PFL + USBH2_EHCI_MEM_PFL_SIZE)
#define  USBH2_EHCI_MEM_QH_SIZE                      (USBH2_HC_EHCI_PIPE_NUM*64)
#define  USBH2_EHCI_MEM_QTD                          (USBH2_EHCI_MEM_QH  + USBH2_EHCI_MEM_QH_SIZE)
#define  USBH2_EHCI_MEM_QTD_SIZE                     (USBH2_HC_EHCI_PIPE_NUM*32)
#define  USBH2_EHCI_MEM_POOL_ADDR                    (USBH2_EHCI_MEM_PFL + USBH2_EHCI_MEM_PFL_SIZE + USBH2_EHCI_MEM_QH_SIZE + USBH2_EHCI_MEM_QTD_SIZE)
#define  USBH2_EHCI_MEM_POOL_SIZE                    (USBH2_HC_EHCI_MEM_POOL_SIZE + 8 * USBH2_HC_PIPE_NUM + 32 + 4)

extern   uint32_t             usbh2_ehci_pfl        [(USBH2_EHCI_MEM_PFL_SIZE  +3)/4];
#if defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
         uint32_t             usbh2_ehci_pfl        [(USBH2_EHCI_MEM_PFL_SIZE  +3)/4] __AT_MEM2(USBH2_HC_EHCI_MEM_POOL_ADDR) __SECTION_MEM2(USBH2_EHCI_PFL) __ALIGNED_MEM2(4096);
#else
         uint32_t             usbh2_ehci_pfl        [(USBH2_EHCI_MEM_PFL_SIZE  +3)/4] __AT_MEM2(USBH2_EHCI_MEM_PFL)          __SECTION_MEM2(USBH2_EHCI_PFL) __ALIGNED_MEM2(4096);
#endif
extern   uint32_t             usbh2_ehci_qh         [(USBH2_EHCI_MEM_QH_SIZE   +3)/4];
#if defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
         uint32_t             usbh2_ehci_qh         [(USBH2_EHCI_MEM_QH_SIZE   +3)/4] __AT_MEM2(USBH2_HC_EHCI_MEM_POOL_ADDR) __ALIGNED_MEM2(64);
#else
         uint32_t             usbh2_ehci_qh         [(USBH2_EHCI_MEM_QH_SIZE   +3)/4] __AT_MEM2(USBH2_EHCI_MEM_QH)           __ALIGNED_MEM2(64);
#endif
extern   uint32_t             usbh2_ehci_qtd        [(USBH2_EHCI_MEM_QTD_SIZE  +3)/4];
#if defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
         uint32_t             usbh2_ehci_qtd        [(USBH2_EHCI_MEM_QTD_SIZE  +3)/4] __AT_MEM2(USBH2_HC_EHCI_MEM_POOL_ADDR) __ALIGNED_MEM2(32);
#else
         uint32_t             usbh2_ehci_qtd        [(USBH2_EHCI_MEM_QTD_SIZE  +3)/4] __AT_MEM2(USBH2_EHCI_MEM_QTD)          __ALIGNED_MEM2(32);
#endif
extern   
const    uint8_t              usbh2_power;
const    uint8_t              usbh2_power =          (uint8_t)(USBH2_HC_EHCI_POWER/2);
extern 
const    uint8_t              usbh2_mem_pool_reloc;
const    uint8_t              usbh2_mem_pool_reloc =  USBH2_HC_EHCI_MEM_POOL_RELOC;
extern   uint32_t             usbh2_mem_pool        [(USBH2_EHCI_MEM_POOL_SIZE +3)/4];
#if defined (__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
         uint32_t             usbh2_mem_pool        [(USBH2_EHCI_MEM_POOL_SIZE +3)/4] __AT_MEM2(USBH2_HC_EHCI_MEM_POOL_ADDR);
#else
         uint32_t             usbh2_mem_pool        [(USBH2_EHCI_MEM_POOL_SIZE +3)/4] __AT_MEM2(USBH2_EHCI_MEM_POOL_ADDR);
#endif
extern 
const    uint32_t             usbh2_mem_pool_size;
const    uint32_t             usbh2_mem_pool_size = ((USBH2_EHCI_MEM_POOL_SIZE +3)/4)*4;

extern   USBH_EHCI_t          usbh2_ehci;
         USBH_EHCI_t          usbh2_ehci = {         (uint32_t *)USBH2_HC_EHCI_BASE_ADDRESS,
                                                      USBH2_HC_EHCI_PIPE_NUM,
                                                      USBH2_HC_EHCI_PIPE_NUM,
                                                      0U,
                                                      0U,
                                                      1024U,
                                                      0U, // padding byte
                                                     &usbh2_ehci_pfl[0],
                                                     &usbh2_ehci_qh[0],
                                                     &usbh2_ehci_qtd[0],
                                                      NULL,
                                                      NULL,
                                                      NULL,
                                                     &usbh2_transfer_info[0] };
extern   USBH_HC_t           *usbh2_hc_ptr;
         USBH_HC_t           *usbh2_hc_ptr   =        NULL;
extern   USBH_EHCI_t         *usbh2_ehci_ptr;
         USBH_EHCI_t         *usbh2_ehci_ptr =       &usbh2_ehci;
extern   USBH_OHCI_t         *usbh2_ohci_ptr;
         USBH_OHCI_t         *usbh2_ohci_ptr =        NULL;
#endif

extern  void USBH2_Core_Thread                        (void const *arg);
#ifndef USBH2_CORE_THREAD_STACK_SIZE
#define USBH2_CORE_THREAD_STACK_SIZE                  0
#endif
#ifndef USBH2_CORE_THREAD_PRIORITY
#define USBH2_CORE_THREAD_PRIORITY                    osPriorityAboveNormal
#endif
osThreadExt(USBH2_Core_Thread);
osThreadDef(USBH2_Core_Thread, USBH2_CORE_THREAD_PRIORITY, 1U, USBH2_CORE_THREAD_STACK_SIZE);
